:- use_module(library(clpfd)).
:- use_module('/afs/inria.fr/rocq/home/contraintes/common/src/rules2cp/interpreter/prolog/r2cp.pl').
:- init_interpreter.



rcp_first(_A_) :- 
	rcp_var(from(first,0,1), First),
	rcp_rec([start=First,duration=0], _A_).

rcp_first_search(_A_) :- 
	rcp_var(from(first,0,1), First),
	rcp_rec([start=First,duration=0], _A_).

rcp_a1(_A_) :- 
	rcp_var(from(a1,0,1), A1),
	rcp_rec([start=A1,duration=4], _A_).

rcp_a1_search(_A_) :- 
	rcp_var(from(a1,0,1), A1),
	rcp_rec([start=A1,duration=4], _A_).

rcp_a2(_A_) :- 
	rcp_var(from(a2,0,1), A2),
	rcp_rec([start=A2,duration=2], _A_).

rcp_a2_search(_A_) :- 
	rcp_var(from(a2,0,1), A2),
	rcp_rec([start=A2,duration=2], _A_).

rcp_a3(_A_) :- 
	rcp_var(from(a3,0,1), A3),
	rcp_rec([start=A3,duration=2], _A_).

rcp_a3_search(_A_) :- 
	rcp_var(from(a3,0,1), A3),
	rcp_rec([start=A3,duration=2], _A_).

rcp_a4(_A_) :- 
	rcp_var(from(a4,0,1), A4),
	rcp_rec([start=A4,duration=2], _A_).

rcp_a4_search(_A_) :- 
	rcp_var(from(a4,0,1), A4),
	rcp_rec([start=A4,duration=2], _A_).

rcp_a5(_A_) :- 
	rcp_var(from(a5,0,1), A5),
	rcp_rec([start=A5,duration=2], _A_).

rcp_a5_search(_A_) :- 
	rcp_var(from(a5,0,1), A5),
	rcp_rec([start=A5,duration=2], _A_).

rcp_a6(_A_) :- 
	rcp_var(from(a6,0,1), A6),
	rcp_rec([start=A6,duration=5], _A_).

rcp_a6_search(_A_) :- 
	rcp_var(from(a6,0,1), A6),
	rcp_rec([start=A6,duration=5], _A_).

rcp_p1(_A_) :- 
	rcp_var(from(p1,0,1), P1),
	rcp_rec([start=P1,duration=20], _A_).

rcp_p1_search(_A_) :- 
	rcp_var(from(p1,0,1), P1),
	rcp_rec([start=P1,duration=20], _A_).

rcp_p2(_A_) :- 
	rcp_var(from(p2,0,1), P2),
	rcp_rec([start=P2,duration=13], _A_).

rcp_p2_search(_A_) :- 
	rcp_var(from(p2,0,1), P2),
	rcp_rec([start=P2,duration=13], _A_).

rcp_ue(_A_) :- 
	rcp_var(from(ue,0,1), Ue),
	rcp_rec([start=Ue,duration=10], _A_).

rcp_ue_search(_A_) :- 
	rcp_var(from(ue,0,1), Ue),
	rcp_rec([start=Ue,duration=10], _A_).

rcp_s1(_A_) :- 
	rcp_var(from(s1,0,1), S1),
	rcp_rec([start=S1,duration=8], _A_).

rcp_s1_search(_A_) :- 
	rcp_var(from(s1,0,1), S1),
	rcp_rec([start=S1,duration=8], _A_).

rcp_s2(_A_) :- 
	rcp_var(from(s2,0,1), S2),
	rcp_rec([start=S2,duration=4], _A_).

rcp_s2_search(_A_) :- 
	rcp_var(from(s2,0,1), S2),
	rcp_rec([start=S2,duration=4], _A_).

rcp_s3(_A_) :- 
	rcp_var(from(s3,0,1), S3),
	rcp_rec([start=S3,duration=4], _A_).

rcp_s3_search(_A_) :- 
	rcp_var(from(s3,0,1), S3),
	rcp_rec([start=S3,duration=4], _A_).

rcp_s4(_A_) :- 
	rcp_var(from(s4,0,1), S4),
	rcp_rec([start=S4,duration=4], _A_).

rcp_s4_search(_A_) :- 
	rcp_var(from(s4,0,1), S4),
	rcp_rec([start=S4,duration=4], _A_).

rcp_s5(_A_) :- 
	rcp_var(from(s5,0,1), S5),
	rcp_rec([start=S5,duration=4], _A_).

rcp_s5_search(_A_) :- 
	rcp_var(from(s5,0,1), S5),
	rcp_rec([start=S5,duration=4], _A_).

rcp_s6(_A_) :- 
	rcp_var(from(s6,0,1), S6),
	rcp_rec([start=S6,duration=10], _A_).

rcp_s6_search(_A_) :- 
	rcp_var(from(s6,0,1), S6),
	rcp_rec([start=S6,duration=10], _A_).

rcp_b1(_A_) :- 
	rcp_var(from(b1,0,1), B1),
	rcp_rec([start=B1,duration=1], _A_).

rcp_b1_search(_A_) :- 
	rcp_var(from(b1,0,1), B1),
	rcp_rec([start=B1,duration=1], _A_).

rcp_b2(_A_) :- 
	rcp_var(from(b2,0,1), B2),
	rcp_rec([start=B2,duration=1], _A_).

rcp_b2_search(_A_) :- 
	rcp_var(from(b2,0,1), B2),
	rcp_rec([start=B2,duration=1], _A_).

rcp_b3(_A_) :- 
	rcp_var(from(b3,0,1), B3),
	rcp_rec([start=B3,duration=1], _A_).

rcp_b3_search(_A_) :- 
	rcp_var(from(b3,0,1), B3),
	rcp_rec([start=B3,duration=1], _A_).

rcp_b4(_A_) :- 
	rcp_var(from(b4,0,1), B4),
	rcp_rec([start=B4,duration=1], _A_).

rcp_b4_search(_A_) :- 
	rcp_var(from(b4,0,1), B4),
	rcp_rec([start=B4,duration=1], _A_).

rcp_b5(_A_) :- 
	rcp_var(from(b5,0,1), B5),
	rcp_rec([start=B5,duration=1], _A_).

rcp_b5_search(_A_) :- 
	rcp_var(from(b5,0,1), B5),
	rcp_rec([start=B5,duration=1], _A_).

rcp_b6(_A_) :- 
	rcp_var(from(b6,0,1), B6),
	rcp_rec([start=B6,duration=1], _A_).

rcp_b6_search(_A_) :- 
	rcp_var(from(b6,0,1), B6),
	rcp_rec([start=B6,duration=1], _A_).

rcp_ab1(_A_) :- 
	rcp_var(from(ab1,0,1), Ab1),
	rcp_rec([start=Ab1,duration=1], _A_).

rcp_ab1_search(_A_) :- 
	rcp_var(from(ab1,0,1), Ab1),
	rcp_rec([start=Ab1,duration=1], _A_).

rcp_ab2(_A_) :- 
	rcp_var(from(ab2,0,1), Ab2),
	rcp_rec([start=Ab2,duration=1], _A_).

rcp_ab2_search(_A_) :- 
	rcp_var(from(ab2,0,1), Ab2),
	rcp_rec([start=Ab2,duration=1], _A_).

rcp_ab3(_A_) :- 
	rcp_var(from(ab3,0,1), Ab3),
	rcp_rec([start=Ab3,duration=1], _A_).

rcp_ab3_search(_A_) :- 
	rcp_var(from(ab3,0,1), Ab3),
	rcp_rec([start=Ab3,duration=1], _A_).

rcp_ab4(_A_) :- 
	rcp_var(from(ab4,0,1), Ab4),
	rcp_rec([start=Ab4,duration=1], _A_).

rcp_ab4_search(_A_) :- 
	rcp_var(from(ab4,0,1), Ab4),
	rcp_rec([start=Ab4,duration=1], _A_).

rcp_ab5(_A_) :- 
	rcp_var(from(ab5,0,1), Ab5),
	rcp_rec([start=Ab5,duration=1], _A_).

rcp_ab5_search(_A_) :- 
	rcp_var(from(ab5,0,1), Ab5),
	rcp_rec([start=Ab5,duration=1], _A_).

rcp_ab6(_A_) :- 
	rcp_var(from(ab6,0,1), Ab6),
	rcp_rec([start=Ab6,duration=1], _A_).

rcp_ab6_search(_A_) :- 
	rcp_var(from(ab6,0,1), Ab6),
	rcp_rec([start=Ab6,duration=1], _A_).

rcp_m1(_A_) :- 
	rcp_var(from(m1,0,1), M1),
	rcp_rec([start=M1,duration=16], _A_).

rcp_m1_search(_A_) :- 
	rcp_var(from(m1,0,1), M1),
	rcp_rec([start=M1,duration=16], _A_).

rcp_m2(_A_) :- 
	rcp_var(from(m2,0,1), M2),
	rcp_rec([start=M2,duration=8], _A_).

rcp_m2_search(_A_) :- 
	rcp_var(from(m2,0,1), M2),
	rcp_rec([start=M2,duration=8], _A_).

rcp_m3(_A_) :- 
	rcp_var(from(m3,0,1), M3),
	rcp_rec([start=M3,duration=8], _A_).

rcp_m3_search(_A_) :- 
	rcp_var(from(m3,0,1), M3),
	rcp_rec([start=M3,duration=8], _A_).

rcp_m4(_A_) :- 
	rcp_var(from(m4,0,1), M4),
	rcp_rec([start=M4,duration=8], _A_).

rcp_m4_search(_A_) :- 
	rcp_var(from(m4,0,1), M4),
	rcp_rec([start=M4,duration=8], _A_).

rcp_m5(_A_) :- 
	rcp_var(from(m5,0,1), M5),
	rcp_rec([start=M5,duration=8], _A_).

rcp_m5_search(_A_) :- 
	rcp_var(from(m5,0,1), M5),
	rcp_rec([start=M5,duration=8], _A_).

rcp_m6(_A_) :- 
	rcp_var(from(m6,0,1), M6),
	rcp_rec([start=M6,duration=20], _A_).

rcp_m6_search(_A_) :- 
	rcp_var(from(m6,0,1), M6),
	rcp_rec([start=M6,duration=20], _A_).

rcp_l1(_A_) :- 
	rcp_var(from(l1,0,1), L1),
	rcp_rec([start=L1,duration=2], _A_).

rcp_l1_search(_A_) :- 
	rcp_var(from(l1,0,1), L1),
	rcp_rec([start=L1,duration=2], _A_).

rcp_t1(_A_) :- 
	rcp_var(from(t1,0,1), T1),
	rcp_rec([start=T1,duration=12], _A_).

rcp_t1_search(_A_) :- 
	rcp_var(from(t1,0,1), T1),
	rcp_rec([start=T1,duration=12], _A_).

rcp_t2(_A_) :- 
	rcp_var(from(t2,0,1), T2),
	rcp_rec([start=T2,duration=12], _A_).

rcp_t2_search(_A_) :- 
	rcp_var(from(t2,0,1), T2),
	rcp_rec([start=T2,duration=12], _A_).

rcp_t3(_A_) :- 
	rcp_var(from(t3,0,1), T3),
	rcp_rec([start=T3,duration=12], _A_).

rcp_t3_search(_A_) :- 
	rcp_var(from(t3,0,1), T3),
	rcp_rec([start=T3,duration=12], _A_).

rcp_t4(_A_) :- 
	rcp_var(from(t4,0,1), T4),
	rcp_rec([start=T4,duration=12], _A_).

rcp_t4_search(_A_) :- 
	rcp_var(from(t4,0,1), T4),
	rcp_rec([start=T4,duration=12], _A_).

rcp_t5(_A_) :- 
	rcp_var(from(t5,0,1), T5),
	rcp_rec([start=T5,duration=12], _A_).

rcp_t5_search(_A_) :- 
	rcp_var(from(t5,0,1), T5),
	rcp_rec([start=T5,duration=12], _A_).

rcp_ua(_A_) :- 
	rcp_var(from(ua,0,1), Ua),
	rcp_rec([start=Ua,duration=10], _A_).

rcp_ua_search(_A_) :- 
	rcp_var(from(ua,0,1), Ua),
	rcp_rec([start=Ua,duration=10], _A_).

rcp_v1(_A_) :- 
	rcp_var(from(v1,0,1), V1),
	rcp_rec([start=V1,duration=15], _A_).

rcp_v1_search(_A_) :- 
	rcp_var(from(v1,0,1), V1),
	rcp_rec([start=V1,duration=15], _A_).

rcp_v2(_A_) :- 
	rcp_var(from(v2,0,1), V2),
	rcp_rec([start=V2,duration=10], _A_).

rcp_v2_search(_A_) :- 
	rcp_var(from(v2,0,1), V2),
	rcp_rec([start=V2,duration=10], _A_).

rcp_k1(_A_) :- 
	rcp_var(from(k1,0,1), K1),
	rcp_rec([start=K1,duration=0], _A_).

rcp_k1_search(_A_) :- 
	rcp_var(from(k1,0,1), K1),
	rcp_rec([start=K1,duration=0], _A_).

rcp_k2(_A_) :- 
	rcp_var(from(k2,0,1), K2),
	rcp_rec([start=K2,duration=0], _A_).

rcp_k2_search(_A_) :- 
	rcp_var(from(k2,0,1), K2),
	rcp_rec([start=K2,duration=0], _A_).

rcp_last(_A_) :- 
	rcp_var(from(last,0,1), Last),
	rcp_rec([start=Last,duration=0], _A_).

rcp_last_search(_A_) :- 
	rcp_var(from(last,0,1), Last),
	rcp_rec([start=Last,duration=0], _A_).

rcp_cost(_B_) :- 
	last(_A_),
	rcp_att(start, _A_, _B_).

rcp_cost_search(_B_) :- 
	rcp_last_search(_A_),
	rcp_att(start, _A_, _B_).

rcp_sum_foldr_1([], _, []) :- 
	!.
rcp_sum_foldr_1([T_107|Tail], [], [_A_|_B_]) :- 
	rcp_att(duration, T_107, _A_),
	rcp_sum_foldr_1(Tail, [], _B_).

rcp_sum_foldr_1_search([], _, []) :- 
	!.
rcp_sum_foldr_1_search([T_107|Tail], [], [_C_|_D_]) :- 
	rcp_att(duration, T_107, _C_),
	rcp_sum_foldr_1_search(Tail, [], _D_).

rcp_maxDuration(_C_) :- 
	tasks(_A_),
	rcp_sum_foldr_1(_A_, [], _B_),
	rcp_sum(_B_, _C_).

rcp_maxDuration_search(_C_) :- 
	rcp_tasks_search(_A_),
	rcp_sum_foldr_1_search(_A_, [], _B_),
	rcp_sum_search(_B_, _C_).

rcp_tasks(_V1_) :- 
	first(_A_),
	a1(_B_),
	a2(_C_),
	a3(_D_),
	a4(_E_),
	a5(_F_),
	a6(_G_),
	p1(_H_),
	p2(_I_),
	ue(_J_),
	s1(_K_),
	s2(_L_),
	s3(_M_),
	s4(_N_),
	s5(_O_),
	s6(_P_),
	b1(_Q_),
	b2(_R_),
	b3(_S_),
	b4(_T_),
	b5(_U_),
	b6(_V_),
	ab1(_W_),
	ab2(_X_),
	ab3(_Y_),
	ab4(_Z_),
	ab5(_B1_),
	ab6(_C1_),
	m1(_D1_),
	m2(_E1_),
	m3(_F1_),
	m4(_G1_),
	m5(_H1_),
	m6(_I1_),
	l1(_J1_),
	t1(_K1_),
	t2(_L1_),
	t3(_M1_),
	t4(_N1_),
	t5(_O1_),
	ua(_P1_),
	v1(_Q1_),
	v2(_R1_),
	k1(_S1_),
	k2(_T1_),
	last(_U1_),
	_V1_=[_A_,_B_,_C_,_D_,_E_,_F_,_G_,_H_,_I_,_J_,_K_,_L_,_M_,_N_,_O_,_P_,_Q_,_R_,_S_,_T_,_U_,_V_,_W_,_X_,_Y_,_Z_,_B1_,_C1_,_D1_,_E1_,_F1_,_G1_,_H1_,_I1_,_J1_,_K1_,_L1_,_M1_,_N1_,_O1_,_P1_,_Q1_,_R1_,_S1_,_T1_,_U1_].

rcp_tasks_search(_V1_) :- 
	rcp_first_search(_A_),
	rcp_a1_search(_B_),
	rcp_a2_search(_C_),
	rcp_a3_search(_D_),
	rcp_a4_search(_E_),
	rcp_a5_search(_F_),
	rcp_a6_search(_G_),
	rcp_p1_search(_H_),
	rcp_p2_search(_I_),
	rcp_ue_search(_J_),
	rcp_s1_search(_K_),
	rcp_s2_search(_L_),
	rcp_s3_search(_M_),
	rcp_s4_search(_N_),
	rcp_s5_search(_O_),
	rcp_s6_search(_P_),
	rcp_b1_search(_Q_),
	rcp_b2_search(_R_),
	rcp_b3_search(_S_),
	rcp_b4_search(_T_),
	rcp_b5_search(_U_),
	rcp_b6_search(_V_),
	rcp_ab1_search(_W_),
	rcp_ab2_search(_X_),
	rcp_ab3_search(_Y_),
	rcp_ab4_search(_Z_),
	rcp_ab5_search(_B1_),
	rcp_ab6_search(_C1_),
	rcp_m1_search(_D1_),
	rcp_m2_search(_E1_),
	rcp_m3_search(_F1_),
	rcp_m4_search(_G1_),
	rcp_m5_search(_H1_),
	rcp_m6_search(_I1_),
	rcp_l1_search(_J1_),
	rcp_t1_search(_K1_),
	rcp_t2_search(_L1_),
	rcp_t3_search(_M1_),
	rcp_t4_search(_N1_),
	rcp_t5_search(_O1_),
	rcp_ua_search(_P1_),
	rcp_v1_search(_Q1_),
	rcp_v2_search(_R1_),
	rcp_k1_search(_S1_),
	rcp_k2_search(_T1_),
	rcp_last_search(_U1_),
	_V1_=[_A_,_B_,_C_,_D_,_E_,_F_,_G_,_H_,_I_,_J_,_K_,_L_,_M_,_N_,_O_,_P_,_Q_,_R_,_S_,_T_,_U_,_V_,_W_,_X_,_Y_,_Z_,_B1_,_C1_,_D1_,_E1_,_F1_,_G1_,_H1_,_I1_,_J1_,_K1_,_L1_,_M1_,_N1_,_O1_,_P1_,_Q1_,_R1_,_S1_,_T1_,_U1_].

rcp_precedences_list(_D5_) :- 
	first(_A_),
	a1(_B_),
	first(_C_),
	a2(_D_),
	first(_E_),
	a3(_F_),
	first(_G_),
	a4(_H_),
	first(_I_),
	a5(_J_),
	first(_K_),
	a6(_L_),
	first(_M_),
	ue(_N_),
	a1(_O_),
	s1(_P_),
	a2(_Q_),
	s2(_R_),
	a5(_S_),
	s5(_T_),
	a6(_U_),
	s6(_V_),
	a3(_W_),
	p1(_X_),
	a4(_Y_),
	p2(_Z_),
	p1(_B1_),
	s3(_C1_),
	p2(_D1_),
	s4(_E1_),
	p1(_F1_),
	k1(_G1_),
	p2(_H1_),
	k1(_I1_),
	s1(_J1_),
	b1(_K1_),
	s2(_L1_),
	b2(_M1_),
	s3(_N1_),
	b3(_O1_),
	s4(_P1_),
	b4(_Q1_),
	s5(_R1_),
	b5(_S1_),
	s6(_T1_),
	b6(_U1_),
	b1(_V1_),
	ab1(_W1_),
	b2(_X1_),
	ab2(_Y1_),
	b3(_Z1_),
	ab3(_A2_),
	b4(_B2_),
	ab4(_C2_),
	b5(_D2_),
	ab5(_E2_),
	b6(_F2_),
	ab6(_G2_),
	ab1(_H2_),
	m1(_I2_),
	ab2(_J2_),
	m2(_K2_),
	ab3(_L2_),
	m3(_M2_),
	ab4(_N2_),
	m4(_O2_),
	ab5(_P2_),
	m5(_Q2_),
	ab6(_R2_),
	m6(_S2_),
	m1(_T2_),
	t1(_U2_),
	m2(_V2_),
	t1(_W2_),
	m2(_X2_),
	t2(_Y2_),
	m3(_Z2_),
	t2(_A3_),
	m3(_B3_),
	t3(_C3_),
	m4(_D3_),
	t3(_E3_),
	m4(_F3_),
	t4(_G3_),
	m5(_H3_),
	t4(_I3_),
	m5(_J3_),
	t5(_K3_),
	m6(_L3_),
	t5(_M3_),
	m1(_N3_),
	k2(_O3_),
	m2(_P3_),
	k2(_Q3_),
	m3(_R3_),
	k2(_S3_),
	m4(_T3_),
	k2(_U3_),
	m5(_V3_),
	k2(_W3_),
	m6(_X3_),
	k2(_Y3_),
	l1(_Z3_),
	t1(_A4_),
	l1(_B4_),
	t2(_C4_),
	l1(_D4_),
	t3(_E4_),
	l1(_F4_),
	t4(_G4_),
	l1(_H4_),
	t5(_I4_),
	t1(_J4_),
	v1(_K4_),
	t5(_L4_),
	v2(_M4_),
	t2(_N4_),
	last(_O4_),
	t3(_P4_),
	last(_Q4_),
	t4(_R4_),
	last(_S4_),
	v1(_T4_),
	last(_U4_),
	v2(_V4_),
	last(_W4_),
	ua(_X4_),
	last(_Y4_),
	k1(_Z4_),
	last(_A5_),
	k2(_B5_),
	last(_C5_),
	_D5_=[[_A_,_B_],[_C_,_D_],[_E_,_F_],[_G_,_H_],[_I_,_J_],[_K_,_L_],[_M_,_N_],[_O_,_P_],[_Q_,_R_],[_S_,_T_],[_U_,_V_],[_W_,_X_],[_Y_,_Z_],[_B1_,_C1_],[_D1_,_E1_],[_F1_,_G1_],[_H1_,_I1_],[_J1_,_K1_],[_L1_,_M1_],[_N1_,_O1_],[_P1_,_Q1_],[_R1_,_S1_],[_T1_,_U1_],[_V1_,_W1_],[_X1_,_Y1_],[_Z1_,_A2_],[_B2_,_C2_],[_D2_,_E2_],[_F2_,_G2_],[_H2_,_I2_],[_J2_,_K2_],[_L2_,_M2_],[_N2_,_O2_],[_P2_,_Q2_],[_R2_,_S2_],[_T2_,_U2_],[_V2_,_W2_],[_X2_,_Y2_],[_Z2_,_A3_],[_B3_,_C3_],[_D3_,_E3_],[_F3_,_G3_],[_H3_,_I3_],[_J3_,_K3_],[_L3_,_M3_],[_N3_,_O3_],[_P3_,_Q3_],[_R3_,_S3_],[_T3_,_U3_],[_V3_,_W3_],[_X3_,_Y3_],[_Z3_,_A4_],[_B4_,_C4_],[_D4_,_E4_],[_F4_,_G4_],[_H4_,_I4_],[_J4_,_K4_],[_L4_,_M4_],[_N4_,_O4_],[_P4_,_Q4_],[_R4_,_S4_],[_T4_,_U4_],[_V4_,_W4_],[_X4_,_Y4_],[_Z4_,_A5_],[_B5_,_C5_]].

rcp_precedences_list_search(_D5_) :- 
	rcp_first_search(_A_),
	rcp_a1_search(_B_),
	rcp_first_search(_C_),
	rcp_a2_search(_D_),
	rcp_first_search(_E_),
	rcp_a3_search(_F_),
	rcp_first_search(_G_),
	rcp_a4_search(_H_),
	rcp_first_search(_I_),
	rcp_a5_search(_J_),
	rcp_first_search(_K_),
	rcp_a6_search(_L_),
	rcp_first_search(_M_),
	rcp_ue_search(_N_),
	rcp_a1_search(_O_),
	rcp_s1_search(_P_),
	rcp_a2_search(_Q_),
	rcp_s2_search(_R_),
	rcp_a5_search(_S_),
	rcp_s5_search(_T_),
	rcp_a6_search(_U_),
	rcp_s6_search(_V_),
	rcp_a3_search(_W_),
	rcp_p1_search(_X_),
	rcp_a4_search(_Y_),
	rcp_p2_search(_Z_),
	rcp_p1_search(_B1_),
	rcp_s3_search(_C1_),
	rcp_p2_search(_D1_),
	rcp_s4_search(_E1_),
	rcp_p1_search(_F1_),
	rcp_k1_search(_G1_),
	rcp_p2_search(_H1_),
	rcp_k1_search(_I1_),
	rcp_s1_search(_J1_),
	rcp_b1_search(_K1_),
	rcp_s2_search(_L1_),
	rcp_b2_search(_M1_),
	rcp_s3_search(_N1_),
	rcp_b3_search(_O1_),
	rcp_s4_search(_P1_),
	rcp_b4_search(_Q1_),
	rcp_s5_search(_R1_),
	rcp_b5_search(_S1_),
	rcp_s6_search(_T1_),
	rcp_b6_search(_U1_),
	rcp_b1_search(_V1_),
	rcp_ab1_search(_W1_),
	rcp_b2_search(_X1_),
	rcp_ab2_search(_Y1_),
	rcp_b3_search(_Z1_),
	rcp_ab3_search(_A2_),
	rcp_b4_search(_B2_),
	rcp_ab4_search(_C2_),
	rcp_b5_search(_D2_),
	rcp_ab5_search(_E2_),
	rcp_b6_search(_F2_),
	rcp_ab6_search(_G2_),
	rcp_ab1_search(_H2_),
	rcp_m1_search(_I2_),
	rcp_ab2_search(_J2_),
	rcp_m2_search(_K2_),
	rcp_ab3_search(_L2_),
	rcp_m3_search(_M2_),
	rcp_ab4_search(_N2_),
	rcp_m4_search(_O2_),
	rcp_ab5_search(_P2_),
	rcp_m5_search(_Q2_),
	rcp_ab6_search(_R2_),
	rcp_m6_search(_S2_),
	rcp_m1_search(_T2_),
	rcp_t1_search(_U2_),
	rcp_m2_search(_V2_),
	rcp_t1_search(_W2_),
	rcp_m2_search(_X2_),
	rcp_t2_search(_Y2_),
	rcp_m3_search(_Z2_),
	rcp_t2_search(_A3_),
	rcp_m3_search(_B3_),
	rcp_t3_search(_C3_),
	rcp_m4_search(_D3_),
	rcp_t3_search(_E3_),
	rcp_m4_search(_F3_),
	rcp_t4_search(_G3_),
	rcp_m5_search(_H3_),
	rcp_t4_search(_I3_),
	rcp_m5_search(_J3_),
	rcp_t5_search(_K3_),
	rcp_m6_search(_L3_),
	rcp_t5_search(_M3_),
	rcp_m1_search(_N3_),
	rcp_k2_search(_O3_),
	rcp_m2_search(_P3_),
	rcp_k2_search(_Q3_),
	rcp_m3_search(_R3_),
	rcp_k2_search(_S3_),
	rcp_m4_search(_T3_),
	rcp_k2_search(_U3_),
	rcp_m5_search(_V3_),
	rcp_k2_search(_W3_),
	rcp_m6_search(_X3_),
	rcp_k2_search(_Y3_),
	rcp_l1_search(_Z3_),
	rcp_t1_search(_A4_),
	rcp_l1_search(_B4_),
	rcp_t2_search(_C4_),
	rcp_l1_search(_D4_),
	rcp_t3_search(_E4_),
	rcp_l1_search(_F4_),
	rcp_t4_search(_G4_),
	rcp_l1_search(_H4_),
	rcp_t5_search(_I4_),
	rcp_t1_search(_J4_),
	rcp_v1_search(_K4_),
	rcp_t5_search(_L4_),
	rcp_v2_search(_M4_),
	rcp_t2_search(_N4_),
	rcp_last_search(_O4_),
	rcp_t3_search(_P4_),
	rcp_last_search(_Q4_),
	rcp_t4_search(_R4_),
	rcp_last_search(_S4_),
	rcp_v1_search(_T4_),
	rcp_last_search(_U4_),
	rcp_v2_search(_V4_),
	rcp_last_search(_W4_),
	rcp_ua_search(_X4_),
	rcp_last_search(_Y4_),
	rcp_k1_search(_Z4_),
	rcp_last_search(_A5_),
	rcp_k2_search(_B5_),
	rcp_last_search(_C5_),
	_D5_=[[_A_,_B_],[_C_,_D_],[_E_,_F_],[_G_,_H_],[_I_,_J_],[_K_,_L_],[_M_,_N_],[_O_,_P_],[_Q_,_R_],[_S_,_T_],[_U_,_V_],[_W_,_X_],[_Y_,_Z_],[_B1_,_C1_],[_D1_,_E1_],[_F1_,_G1_],[_H1_,_I1_],[_J1_,_K1_],[_L1_,_M1_],[_N1_,_O1_],[_P1_,_Q1_],[_R1_,_S1_],[_T1_,_U1_],[_V1_,_W1_],[_X1_,_Y1_],[_Z1_,_A2_],[_B2_,_C2_],[_D2_,_E2_],[_F2_,_G2_],[_H2_,_I2_],[_J2_,_K2_],[_L2_,_M2_],[_N2_,_O2_],[_P2_,_Q2_],[_R2_,_S2_],[_T2_,_U2_],[_V2_,_W2_],[_X2_,_Y2_],[_Z2_,_A3_],[_B3_,_C3_],[_D3_,_E3_],[_F3_,_G3_],[_H3_,_I3_],[_J3_,_K3_],[_L3_,_M3_],[_N3_,_O3_],[_P3_,_Q3_],[_R3_,_S3_],[_T3_,_U3_],[_V3_,_W3_],[_X3_,_Y3_],[_Z3_,_A4_],[_B4_,_C4_],[_D4_,_E4_],[_F4_,_G4_],[_H4_,_I4_],[_J4_,_K4_],[_L4_,_M4_],[_N4_,_O4_],[_P4_,_Q4_],[_R4_,_S4_],[_T4_,_U4_],[_V4_,_W4_],[_X4_,_Y4_],[_Z4_,_A5_],[_B5_,_C5_]].

rcp_resource_crane(_G_) :- 
	l1(_A_),
	t1(_B_),
	t2(_C_),
	t3(_D_),
	t4(_E_),
	t5(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_crane_search(_G_) :- 
	rcp_l1_search(_A_),
	rcp_t1_search(_B_),
	rcp_t2_search(_C_),
	rcp_t3_search(_D_),
	rcp_t4_search(_E_),
	rcp_t5_search(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_bricklaying(_G_) :- 
	m1(_A_),
	m2(_B_),
	m3(_C_),
	m4(_D_),
	m5(_E_),
	m6(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_bricklaying_search(_G_) :- 
	rcp_m1_search(_A_),
	rcp_m2_search(_B_),
	rcp_m3_search(_C_),
	rcp_m4_search(_D_),
	rcp_m5_search(_E_),
	rcp_m6_search(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_schal(_G_) :- 
	s1(_A_),
	s2(_B_),
	s3(_C_),
	s4(_D_),
	s5(_E_),
	s6(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_schal_search(_G_) :- 
	rcp_s1_search(_A_),
	rcp_s2_search(_B_),
	rcp_s3_search(_C_),
	rcp_s4_search(_D_),
	rcp_s5_search(_E_),
	rcp_s6_search(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_excavator(_G_) :- 
	a1(_A_),
	a2(_B_),
	a3(_C_),
	a4(_D_),
	a5(_E_),
	a6(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_excavator_search(_G_) :- 
	rcp_a1_search(_A_),
	rcp_a2_search(_B_),
	rcp_a3_search(_C_),
	rcp_a4_search(_D_),
	rcp_a5_search(_E_),
	rcp_a6_search(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_ram(_C_) :- 
	p1(_A_),
	p2(_B_),
	_C_=[_A_,_B_].

rcp_resource_ram_search(_C_) :- 
	rcp_p1_search(_A_),
	rcp_p2_search(_B_),
	_C_=[_A_,_B_].

rcp_resource_pump(_G_) :- 
	b1(_A_),
	b2(_B_),
	b3(_C_),
	b4(_D_),
	b5(_E_),
	b6(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_pump_search(_G_) :- 
	rcp_b1_search(_A_),
	rcp_b2_search(_B_),
	rcp_b3_search(_C_),
	rcp_b4_search(_D_),
	rcp_b5_search(_E_),
	rcp_b6_search(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_caterpillar(_C_) :- 
	v1(_A_),
	v2(_B_),
	_C_=[_A_,_B_].

rcp_resource_caterpillar_search(_C_) :- 
	rcp_v1_search(_A_),
	rcp_v2_search(_B_),
	_C_=[_A_,_B_].

rcp_resources(_H_) :- 
	resource_crane(_A_),
	resource_bricklaying(_B_),
	resource_schal(_C_),
	resource_excavator(_D_),
	resource_ram(_E_),
	resource_pump(_F_),
	resource_caterpillar(_G_),
	_H_=[_A_,_B_,_C_,_D_,_E_,_F_,_G_].

rcp_resources_search(_H_) :- 
	rcp_resource_crane_search(_A_),
	rcp_resource_bricklaying_search(_B_),
	rcp_resource_schal_search(_C_),
	rcp_resource_excavator_search(_D_),
	rcp_resource_ram_search(_E_),
	rcp_resource_pump_search(_F_),
	rcp_resource_caterpillar_search(_G_),
	_H_=[_A_,_B_,_C_,_D_,_E_,_F_,_G_].

rcp_max_nf_list(_O_) :- 
	first(_A_),
	l1(_B_),
	a1(_C_),
	s1(_D_),
	a2(_E_),
	s2(_F_),
	a5(_G_),
	s5(_H_),
	a6(_I_),
	s6(_J_),
	p1(_K_),
	s3(_L_),
	p2(_M_),
	s4(_N_),
	_O_=[[_A_,_B_,30],[_C_,_D_,3],[_E_,_F_,3],[_G_,_H_,3],[_I_,_J_,3],[_K_,_L_,3],[_M_,_N_,3]].

rcp_max_nf_list_search(_O_) :- 
	rcp_first_search(_A_),
	rcp_l1_search(_B_),
	rcp_a1_search(_C_),
	rcp_s1_search(_D_),
	rcp_a2_search(_E_),
	rcp_s2_search(_F_),
	rcp_a5_search(_G_),
	rcp_s5_search(_H_),
	rcp_a6_search(_I_),
	rcp_s6_search(_J_),
	rcp_p1_search(_K_),
	rcp_s3_search(_L_),
	rcp_p2_search(_M_),
	rcp_s4_search(_N_),
	_O_=[[_A_,_B_,30],[_C_,_D_,3],[_E_,_F_,3],[_G_,_H_,3],[_I_,_J_,3],[_K_,_L_,3],[_M_,_N_,3]].

rcp_min_sf_list(_M_) :- 
	ua(_A_),
	m1(_B_),
	ua(_C_),
	m2(_D_),
	ua(_E_),
	m3(_F_),
	ua(_G_),
	m4(_H_),
	ua(_I_),
	m5(_J_),
	ua(_K_),
	m6(_L_),
	_M_=[[_A_,_B_,2],[_C_,_D_,2],[_E_,_F_,2],[_G_,_H_,2],[_I_,_J_,2],[_K_,_L_,2]].

rcp_min_sf_list_search(_M_) :- 
	rcp_ua_search(_A_),
	rcp_m1_search(_B_),
	rcp_ua_search(_C_),
	rcp_m2_search(_D_),
	rcp_ua_search(_E_),
	rcp_m3_search(_F_),
	rcp_ua_search(_G_),
	rcp_m4_search(_H_),
	rcp_ua_search(_I_),
	rcp_m5_search(_J_),
	rcp_ua_search(_K_),
	rcp_m6_search(_L_),
	_M_=[[_A_,_B_,2],[_C_,_D_,2],[_E_,_F_,2],[_G_,_H_,2],[_I_,_J_,2],[_K_,_L_,2]].

rcp_max_ef_list(_M_) :- 
	s1(_A_),
	b1(_B_),
	s2(_C_),
	b2(_D_),
	s3(_E_),
	b3(_F_),
	s4(_G_),
	b4(_H_),
	s5(_I_),
	b5(_J_),
	s6(_K_),
	b6(_L_),
	_M_=[[_A_,_B_,4],[_C_,_D_,4],[_E_,_F_,4],[_G_,_H_,4],[_I_,_J_,4],[_K_,_L_,4]].

rcp_max_ef_list_search(_M_) :- 
	rcp_s1_search(_A_),
	rcp_b1_search(_B_),
	rcp_s2_search(_C_),
	rcp_b2_search(_D_),
	rcp_s3_search(_E_),
	rcp_b3_search(_F_),
	rcp_s4_search(_G_),
	rcp_b4_search(_H_),
	rcp_s5_search(_I_),
	rcp_b5_search(_J_),
	rcp_s6_search(_K_),
	rcp_b6_search(_L_),
	_M_=[[_A_,_B_,4],[_C_,_D_,4],[_E_,_F_,4],[_G_,_H_,4],[_I_,_J_,4],[_K_,_L_,4]].

rcp_min_nf_list(_C_) :- 
	first(_A_),
	l1(_B_),
	_C_=[[_A_,_B_,30]].

rcp_min_nf_list_search(_C_) :- 
	rcp_first_search(_A_),
	rcp_l1_search(_B_),
	_C_=[[_A_,_B_,30]].

rcp_min_af_list(_M_) :- 
	ue(_A_),
	s1(_B_),
	ue(_C_),
	s2(_D_),
	ue(_E_),
	s3(_F_),
	ue(_G_),
	s4(_H_),
	ue(_I_),
	s5(_J_),
	ue(_K_),
	s6(_L_),
	_M_=[[_A_,_B_,6],[_C_,_D_,6],[_E_,_F_,6],[_G_,_H_,6],[_I_,_J_,6],[_K_,_L_,6]].

rcp_min_af_list_search(_M_) :- 
	rcp_ue_search(_A_),
	rcp_s1_search(_B_),
	rcp_ue_search(_C_),
	rcp_s2_search(_D_),
	rcp_ue_search(_E_),
	rcp_s3_search(_F_),
	rcp_ue_search(_G_),
	rcp_s4_search(_H_),
	rcp_ue_search(_I_),
	rcp_s5_search(_J_),
	rcp_ue_search(_K_),
	rcp_s6_search(_L_),
	_M_=[[_A_,_B_,6],[_C_,_D_,6],[_E_,_F_,6],[_G_,_H_,6],[_I_,_J_,6],[_K_,_L_,6]].

rcp_distances_foldr_2([], _, 1) :- 
	!.
rcp_distances_foldr_2([T_108|Tail], [], _F_) :- 
	fd_and(_D_, _E_, _F_),
	nth1(1, T_108, _A_),
	nth1(2, T_108, _B_),
	nth1(3, T_108, _C_),
	rcp_max_nf(_A_, _B_, _C_, _D_),
	rcp_distances_foldr_2(Tail, [], _E_).

rcp_distances_foldr_2_search([], _, 1) :- 
	!.
rcp_distances_foldr_2_search([T_108|Tail], [], _) :- 
	nth1(1, T_108, _G_),
	nth1(2, T_108, _H_),
	nth1(3, T_108, _I_),
	rcp_max_nf_search(_G_, _H_, _I_, _J_),
	rcp_assert(_J_),
	rcp_distances_foldr_2_search(Tail, [], _K_),
	rcp_assert(_K_).

rcp_distances_foldr_3([], _, 1) :- 
	!.
rcp_distances_foldr_3([T_109|Tail], [], _F_) :- 
	fd_and(_D_, _E_, _F_),
	nth1(1, T_109, _A_),
	nth1(2, T_109, _B_),
	nth1(3, T_109, _C_),
	rcp_min_sf(_A_, _B_, _C_, _D_),
	rcp_distances_foldr_3(Tail, [], _E_).

rcp_distances_foldr_3_search([], _, 1) :- 
	!.
rcp_distances_foldr_3_search([T_109|Tail], [], _) :- 
	nth1(1, T_109, _G_),
	nth1(2, T_109, _H_),
	nth1(3, T_109, _I_),
	rcp_min_sf_search(_G_, _H_, _I_, _J_),
	rcp_assert(_J_),
	rcp_distances_foldr_3_search(Tail, [], _K_),
	rcp_assert(_K_).

rcp_distances_foldr_4([], _, 1) :- 
	!.
rcp_distances_foldr_4([T_110|Tail], [], _F_) :- 
	fd_and(_D_, _E_, _F_),
	nth1(1, T_110, _A_),
	nth1(2, T_110, _B_),
	nth1(3, T_110, _C_),
	rcp_max_ef(_A_, _B_, _C_, _D_),
	rcp_distances_foldr_4(Tail, [], _E_).

rcp_distances_foldr_4_search([], _, 1) :- 
	!.
rcp_distances_foldr_4_search([T_110|Tail], [], _) :- 
	nth1(1, T_110, _G_),
	nth1(2, T_110, _H_),
	nth1(3, T_110, _I_),
	rcp_max_ef_search(_G_, _H_, _I_, _J_),
	rcp_assert(_J_),
	rcp_distances_foldr_4_search(Tail, [], _K_),
	rcp_assert(_K_).

rcp_distances_foldr_5([], _, 1) :- 
	!.
rcp_distances_foldr_5([T_111|Tail], [], _F_) :- 
	fd_and(_D_, _E_, _F_),
	nth1(1, T_111, _A_),
	nth1(2, T_111, _B_),
	nth1(3, T_111, _C_),
	rcp_min_nf(_A_, _B_, _C_, _D_),
	rcp_distances_foldr_5(Tail, [], _E_).

rcp_distances_foldr_5_search([], _, 1) :- 
	!.
rcp_distances_foldr_5_search([T_111|Tail], [], _) :- 
	nth1(1, T_111, _G_),
	nth1(2, T_111, _H_),
	nth1(3, T_111, _I_),
	rcp_min_nf_search(_G_, _H_, _I_, _J_),
	rcp_assert(_J_),
	rcp_distances_foldr_5_search(Tail, [], _K_),
	rcp_assert(_K_).

rcp_distances_foldr_6([], _, 1) :- 
	!.
rcp_distances_foldr_6([T_112|Tail], [], _F_) :- 
	fd_and(_D_, _E_, _F_),
	nth1(1, T_112, _A_),
	nth1(2, T_112, _B_),
	nth1(3, T_112, _C_),
	rcp_min_af(_A_, _B_, _C_, _D_),
	rcp_distances_foldr_6(Tail, [], _E_).

rcp_distances_foldr_6_search([], _, 1) :- 
	!.
rcp_distances_foldr_6_search([T_112|Tail], [], _) :- 
	nth1(1, T_112, _G_),
	nth1(2, T_112, _H_),
	nth1(3, T_112, _I_),
	rcp_min_af_search(_G_, _H_, _I_, _J_),
	rcp_assert(_J_),
	rcp_distances_foldr_6_search(Tail, [], _K_),
	rcp_assert(_K_).

rcp_distances(_N_) :- 
	fd_and(_B_, _M_, _N_),
	max_nf_list(_A_),
	rcp_distances_foldr_2(_A_, [], _B_),
	fd_and(_D_, _L_, _M_),
	min_sf_list(_C_),
	rcp_distances_foldr_3(_C_, [], _D_),
	fd_and(_F_, _K_, _L_),
	max_ef_list(_E_),
	rcp_distances_foldr_4(_E_, [], _F_),
	fd_and(_H_, _J_, _K_),
	min_nf_list(_G_),
	rcp_distances_foldr_5(_G_, [], _H_),
	min_af_list(_I_),
	rcp_distances_foldr_6(_I_, [], _J_).

rcp_distances_search(_K_) :- 
	rcp_max_nf_list_search(_A_),
	rcp_distances_foldr_2_search(_A_, [], _B_),
	rcp_assert(_B_),
	rcp_min_sf_list_search(_C_),
	rcp_distances_foldr_3_search(_C_, [], _D_),
	rcp_assert(_D_),
	rcp_max_ef_list_search(_E_),
	rcp_distances_foldr_4_search(_E_, [], _F_),
	rcp_assert(_F_),
	rcp_min_nf_list_search(_G_),
	rcp_distances_foldr_5_search(_G_, [], _H_),
	rcp_assert(_H_),
	rcp_min_af_list_search(_I_),
	rcp_distances_foldr_6_search(_I_, [], _J_),
	rcp_assert(_J_),
	fd_aeq(_K_, 1).

rcp_tasks_domain(_D_) :- 
	tasks(_A_),
	variables(_A_, _B_),
	maxDuration(_C_),
	domain(_B_, 0, _C_),
	fd_aeq(_D_, 1).

rcp_tasks_domain_search(_D_) :- 
	rcp_tasks_search(_A_),
	variables(_A_, _B_),
	rcp_maxDuration_search(_C_),
	domain(_B_, 0, _C_),
	fd_aeq(_D_, 1).

rcp_precedences_foldr_7([], _, 1) :- 
	!.
rcp_precedences_foldr_7([TaskPair_113|Tail], [], _E_) :- 
	fd_and(_C_, _D_, _E_),
	nth1(1, TaskPair_113, _A_),
	nth1(2, TaskPair_113, _B_),
	rcp_prec(_A_, _B_, _C_),
	rcp_precedences_foldr_7(Tail, [], _D_).

rcp_precedences_foldr_7_search([], _, 1) :- 
	!.
rcp_precedences_foldr_7_search([TaskPair_113|Tail], [], _) :- 
	nth1(1, TaskPair_113, _F_),
	nth1(2, TaskPair_113, _G_),
	rcp_prec_search(_F_, _G_, _H_),
	rcp_assert(_H_),
	rcp_precedences_foldr_7_search(Tail, [], _I_),
	rcp_assert(_I_).

rcp_precedences(_B_) :- 
	precedences_list(_A_),
	rcp_precedences_foldr_7(_A_, [], _B_).

rcp_precedences_search(_B_) :- 
	rcp_precedences_list_search(_A_),
	rcp_precedences_foldr_7_search(_A_, [], _B_).

rcp_disjunctives_foldr_8([], _, 1) :- 
	!.
rcp_disjunctives_foldr_8([Tasks_114|Tail], [], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_disj_pairs(Tasks_114, _A_),
	rcp_disjunctives_foldr_8(Tail, [], _B_).

rcp_disjunctives_foldr_8_search([], _, 1) :- 
	!.
rcp_disjunctives_foldr_8_search([Tasks_114|Tail], [], _) :- 
	rcp_disj_pairs_search(Tasks_114, _D_),
	rcp_assert(_D_),
	rcp_disjunctives_foldr_8_search(Tail, [], _E_),
	rcp_assert(_E_).

rcp_disjunctives(_B_) :- 
	resources(_A_),
	rcp_disjunctives_foldr_8(_A_, [], _B_).

rcp_disjunctives_search(_B_) :- 
	rcp_resources_search(_A_),
	rcp_disjunctives_foldr_8_search(_A_, [], _B_).

rcp_minimize_completion_time(_C_) :- 
	cost(_B_),
	minimize(((rcp_assert(_A_),rcp_disjunctives_search(_A_)),rcp_labeling([_B_])), _B_),
	fd_aeq(_C_, 1).

rcp_minimize_completion_time_search(_C_) :- 
	cost(_B_),
	minimize(((rcp_assert(_A_),rcp_disjunctives_search(_A_)),rcp_labeling([_B_])), _B_),
	fd_aeq(_C_, 1).

rcp_sum_foldr_9([], _, 0) :- 
	!.
rcp_sum_foldr_9([X_115|Tail], [L], _B_) :- 
	rcp_sum_foldr_9(Tail, [L], _A_),
	fd_aeq(X_115+_A_, _B_).

rcp_sum_foldr_9_search([], _, 0) :- 
	!.
rcp_sum_foldr_9_search([X_115|Tail], [L], _D_) :- 
	rcp_sum_foldr_9_search(Tail, [L], _C_),
	fd_aeq(X_115+_C_, _D_).

rcp_sum(L, _A_) :- 
	rcp_sum_foldr_9(L, [L], _A_).

rcp_sum_search(L, _A_) :- 
	rcp_sum_foldr_9_search(L, [L], _A_).

rcp_product_foldr_10([], _, 1) :- 
	!.
rcp_product_foldr_10([X_116|Tail], [L], _B_) :- 
	rcp_product_foldr_10(Tail, [L], _A_),
	fd_aeq(X_116*_A_, _B_).

rcp_product_foldr_10_search([], _, 1) :- 
	!.
rcp_product_foldr_10_search([X_116|Tail], [L], _D_) :- 
	rcp_product_foldr_10_search(Tail, [L], _C_),
	fd_aeq(X_116*_C_, _D_).

rcp_product(L, _A_) :- 
	rcp_product_foldr_10(L, [L], _A_).

rcp_product_search(L, _A_) :- 
	rcp_product_foldr_10_search(L, [L], _A_).

rcp_maximum_foldr_11([], _, -268435456) :- 
	!.
rcp_maximum_foldr_11([X_117|Tail], [L], _B_) :- 
	rcp_maximum_foldr_11(Tail, [L], _A_),
	fd_aeq(max(X_117,_A_), _B_).

rcp_maximum_foldr_11_search([], _, -268435456) :- 
	!.
rcp_maximum_foldr_11_search([X_117|Tail], [L], _D_) :- 
	rcp_maximum_foldr_11_search(Tail, [L], _C_),
	fd_aeq(max(X_117,_C_), _D_).

rcp_maximum(L, _A_) :- 
	rcp_maximum_foldr_11(L, [L], _A_).

rcp_maximum_search(L, _A_) :- 
	rcp_maximum_foldr_11_search(L, [L], _A_).

rcp_minimum_foldr_12([], _, 267999999) :- 
	!.
rcp_minimum_foldr_12([X_118|Tail], [L], _B_) :- 
	rcp_minimum_foldr_12(Tail, [L], _A_),
	fd_aeq(min(X_118,_A_), _B_).

rcp_minimum_foldr_12_search([], _, 267999999) :- 
	!.
rcp_minimum_foldr_12_search([X_118|Tail], [L], _D_) :- 
	rcp_minimum_foldr_12_search(Tail, [L], _C_),
	fd_aeq(min(X_118,_C_), _D_).

rcp_minimum(L, _A_) :- 
	rcp_minimum_foldr_12(L, [L], _A_).

rcp_minimum_search(L, _A_) :- 
	rcp_minimum_foldr_12_search(L, [L], _A_).

rcp_geost_constraint_foldr_14([], _, []) :- 
	!.
rcp_geost_constraint_foldr_14([S_121|Tail], [Dims,I_119,Items], [_A_|_B_]) :- 
	rcp_att(uid, S_121, _A_),
	rcp_geost_constraint_foldr_14(Tail, [Dims,I_119,Items], _B_).

rcp_geost_constraint_foldr_14_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_14_search([S_121|Tail], [Dims,I_119,Items], [_C_|_D_]) :- 
	rcp_att(uid, S_121, _C_),
	rcp_geost_constraint_foldr_14_search(Tail, [Dims,I_119,Items], _D_).

rcp_geost_constraint_foldr_13([], _, []) :- 
	!.
rcp_geost_constraint_foldr_13([I_119|Tail], [Dims,Items], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_att(uid, I_119, _A_),
	rcp_att(shape_index, I_119, _B_),
	rcp_att(shapes, I_119, _C_),
	rcp_geost_constraint_foldr_14(_C_, [Dims,I_119,Items], _D_),
	rcp_att(origin, I_119, _E_),
	rcp_geost_constraint_foldr_13(Tail, [Dims,Items], _F_).

rcp_geost_constraint_foldr_13_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_13_search([I_119|Tail], [Dims,Items], [[_G_,_H_,_J_,_K_]|_L_]) :- 
	rcp_att(uid, I_119, _G_),
	rcp_att(shape_index, I_119, _H_),
	rcp_att(shapes, I_119, _I_),
	rcp_geost_constraint_foldr_14_search(_I_, [Dims,I_119,Items], _J_),
	rcp_att(origin, I_119, _K_),
	rcp_geost_constraint_foldr_13_search(Tail, [Dims,Items], _L_).

rcp_geost_constraint_foldr_17([], _, []) :- 
	!.
rcp_geost_constraint_foldr_17([SB_127|Tail], [Dims,I_122,Items,S_125], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_att(uid, S_125, _A_),
	rcp_att(offset, SB_127, _B_),
	rcp_att(box, SB_127, _C_),
	rcp_att(size, _C_, _D_),
	rcp_geost_constraint_foldr_17(Tail, [Dims,I_122,Items,S_125], _E_).

rcp_geost_constraint_foldr_17_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_17_search([SB_127|Tail], [Dims,I_122,Items,S_125], [[_F_,_G_,_I_]|_J_]) :- 
	rcp_att(uid, S_125, _F_),
	rcp_att(offset, SB_127, _G_),
	rcp_att(box, SB_127, _H_),
	rcp_att(size, _H_, _I_),
	rcp_geost_constraint_foldr_17_search(Tail, [Dims,I_122,Items,S_125], _J_).

rcp_geost_constraint_foldr_16([], _, []) :- 
	!.
rcp_geost_constraint_foldr_16([S_125|Tail], [Dims,I_122,Items], [_B_|_C_]) :- 
	rcp_att(sboxes, S_125, _A_),
	rcp_geost_constraint_foldr_17(_A_, [Dims,I_122,Items,S_125], _B_),
	rcp_geost_constraint_foldr_16(Tail, [Dims,I_122,Items], _C_).

rcp_geost_constraint_foldr_16_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_16_search([S_125|Tail], [Dims,I_122,Items], [_E_|_F_]) :- 
	rcp_att(sboxes, S_125, _D_),
	rcp_geost_constraint_foldr_17_search(_D_, [Dims,I_122,Items,S_125], _E_),
	rcp_geost_constraint_foldr_16_search(Tail, [Dims,I_122,Items], _F_).

rcp_geost_constraint_foldr_15([], _, []) :- 
	!.
rcp_geost_constraint_foldr_15([I_122|Tail], [Dims,Items], [_B_|_C_]) :- 
	rcp_att(shapes, I_122, _A_),
	rcp_geost_constraint_foldr_16(_A_, [Dims,I_122,Items], _B_),
	rcp_geost_constraint_foldr_15(Tail, [Dims,Items], _C_).

rcp_geost_constraint_foldr_15_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_15_search([I_122|Tail], [Dims,Items], [_E_|_F_]) :- 
	rcp_att(shapes, I_122, _D_),
	rcp_geost_constraint_foldr_16_search(_D_, [Dims,I_122,Items], _E_),
	rcp_geost_constraint_foldr_15_search(Tail, [Dims,Items], _F_).

rcp_non_overlapping(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_13(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_15(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_non_overlapping_search(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_13_search(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_15_search(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_geost_constraint_foldr_19([], _, []) :- 
	!.
rcp_geost_constraint_foldr_19([S_130|Tail], [Dims,F,I_128,Items,Patterns], [_A_|_B_]) :- 
	rcp_att(uid, S_130, _A_),
	rcp_geost_constraint_foldr_19(Tail, [Dims,F,I_128,Items,Patterns], _B_).

rcp_geost_constraint_foldr_19_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_19_search([S_130|Tail], [Dims,F,I_128,Items,Patterns], [_C_|_D_]) :- 
	rcp_att(uid, S_130, _C_),
	rcp_geost_constraint_foldr_19_search(Tail, [Dims,F,I_128,Items,Patterns], _D_).

rcp_geost_constraint_foldr_18([], _, []) :- 
	!.
rcp_geost_constraint_foldr_18([I_128|Tail], [Dims,F,Items,Patterns], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_att(uid, I_128, _A_),
	rcp_att(shape_index, I_128, _B_),
	rcp_att(shapes, I_128, _C_),
	rcp_geost_constraint_foldr_19(_C_, [Dims,F,I_128,Items,Patterns], _D_),
	rcp_att(origin, I_128, _E_),
	rcp_geost_constraint_foldr_18(Tail, [Dims,F,Items,Patterns], _F_).

rcp_geost_constraint_foldr_18_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_18_search([I_128|Tail], [Dims,F,Items,Patterns], [[_G_,_H_,_J_,_K_]|_L_]) :- 
	rcp_att(uid, I_128, _G_),
	rcp_att(shape_index, I_128, _H_),
	rcp_att(shapes, I_128, _I_),
	rcp_geost_constraint_foldr_19_search(_I_, [Dims,F,I_128,Items,Patterns], _J_),
	rcp_att(origin, I_128, _K_),
	rcp_geost_constraint_foldr_18_search(Tail, [Dims,F,Items,Patterns], _L_).

rcp_geost_constraint_foldr_22([], _, []) :- 
	!.
rcp_geost_constraint_foldr_22([SB_136|Tail], [Dims,F,I_131,Items,Patterns,S_134], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_att(uid, S_134, _A_),
	rcp_att(offset, SB_136, _B_),
	rcp_att(box, SB_136, _C_),
	rcp_att(size, _C_, _D_),
	rcp_geost_constraint_foldr_22(Tail, [Dims,F,I_131,Items,Patterns,S_134], _E_).

rcp_geost_constraint_foldr_22_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_22_search([SB_136|Tail], [Dims,F,I_131,Items,Patterns,S_134], [[_F_,_G_,_I_]|_J_]) :- 
	rcp_att(uid, S_134, _F_),
	rcp_att(offset, SB_136, _G_),
	rcp_att(box, SB_136, _H_),
	rcp_att(size, _H_, _I_),
	rcp_geost_constraint_foldr_22_search(Tail, [Dims,F,I_131,Items,Patterns,S_134], _J_).

rcp_geost_constraint_foldr_21([], _, []) :- 
	!.
rcp_geost_constraint_foldr_21([S_134|Tail], [Dims,F,I_131,Items,Patterns], [_B_|_C_]) :- 
	rcp_att(sboxes, S_134, _A_),
	rcp_geost_constraint_foldr_22(_A_, [Dims,F,I_131,Items,Patterns,S_134], _B_),
	rcp_geost_constraint_foldr_21(Tail, [Dims,F,I_131,Items,Patterns], _C_).

rcp_geost_constraint_foldr_21_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_21_search([S_134|Tail], [Dims,F,I_131,Items,Patterns], [_E_|_F_]) :- 
	rcp_att(sboxes, S_134, _D_),
	rcp_geost_constraint_foldr_22_search(_D_, [Dims,F,I_131,Items,Patterns,S_134], _E_),
	rcp_geost_constraint_foldr_21_search(Tail, [Dims,F,I_131,Items,Patterns], _F_).

rcp_geost_constraint_foldr_20([], _, []) :- 
	!.
rcp_geost_constraint_foldr_20([I_131|Tail], [Dims,F,Items,Patterns], [_B_|_C_]) :- 
	rcp_att(shapes, I_131, _A_),
	rcp_geost_constraint_foldr_21(_A_, [Dims,F,I_131,Items,Patterns], _B_),
	rcp_geost_constraint_foldr_20(Tail, [Dims,F,Items,Patterns], _C_).

rcp_geost_constraint_foldr_20_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_20_search([I_131|Tail], [Dims,F,Items,Patterns], [_E_|_F_]) :- 
	rcp_att(shapes, I_131, _D_),
	rcp_geost_constraint_foldr_21_search(_D_, [Dims,F,I_131,Items,Patterns], _E_),
	rcp_geost_constraint_foldr_20_search(Tail, [Dims,F,Items,Patterns], _F_).

rcp_non_overlapping(Items, Dims, F, Patterns, _E_) :- 
	rcp_geost_constraint_foldr_18(Items, [Dims,F,Items,Patterns], _A_),
	rcp_geost_constraint_foldr_20(Items, [Dims,F,Items,Patterns], _B_),
	length(Dims, _C_),
	rcp_fixall(F, Patterns, _D_),
	rcp_geost_constraint(_A_, _B_, _C_, [_D_], _E_).

rcp_non_overlapping_search(Items, Dims, F, Patterns, _E_) :- 
	rcp_geost_constraint_foldr_18_search(Items, [Dims,F,Items,Patterns], _A_),
	rcp_geost_constraint_foldr_20_search(Items, [Dims,F,Items,Patterns], _B_),
	length(Dims, _C_),
	rcp_fixall_search(F, Patterns, _D_),
	rcp_geost_constraint(_A_, _B_, _C_, [_D_], _E_).

rcp_end(Task, _C_) :- 
	rcp_att(start, Task, _A_),
	rcp_att(duration, Task, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_end_search(Task, _C_) :- 
	rcp_att(start, Task, _A_),
	rcp_att(duration, Task, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_max_nf(T1, T2, N, _D_) :- 
	rcp_att(start, T2, _A_),
	rcp_end(T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_, _D_).

rcp_max_nf_search(T1, T2, N, _D_) :- 
	rcp_att(start, T2, _A_),
	rcp_end_search(T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_),
	fd_aeq(_D_, 1).

rcp_min_nf(T1, T2, N, _F_) :- 
	rcp_att(start, T2, _A_),
	rcp_att(start, T1, _B_),
	rcp_att(duration, T1, _C_),
	fd_aeq(_B_+_C_, _D_),
	fd_aeq(_D_+N, _E_),
	fd_geq(_A_, _E_, _F_).

rcp_min_nf_search(T1, T2, N, _F_) :- 
	rcp_att(start, T2, _A_),
	rcp_att(start, T1, _B_),
	rcp_att(duration, T1, _C_),
	fd_aeq(_B_+_C_, _D_),
	fd_aeq(_D_+N, _E_),
	fd_geq(_A_, _E_),
	fd_aeq(_F_, 1).

rcp_max_ef(T1, T2, N, _D_) :- 
	rcp_end(T2, _A_),
	rcp_end(T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_, _D_).

rcp_max_ef_search(T1, T2, N, _D_) :- 
	rcp_end_search(T2, _A_),
	rcp_end_search(T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_),
	fd_aeq(_D_, 1).

rcp_min_af(T1, T2, N, _D_) :- 
	rcp_att(start, T2, _A_),
	rcp_att(start, T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_geq(_A_, _C_, _D_).

rcp_min_af_search(T1, T2, N, _D_) :- 
	rcp_att(start, T2, _A_),
	rcp_att(start, T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_geq(_A_, _C_),
	fd_aeq(_D_, 1).

rcp_min_sf(T1, T2, N, _D_) :- 
	rcp_end(T2, _A_),
	rcp_att(start, T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_, _D_).

rcp_min_sf_search(T1, T2, N, _D_) :- 
	rcp_end_search(T2, _A_),
	rcp_att(start, T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_),
	fd_aeq(_D_, 1).

rcp_prec(T1, T2, _C_) :- 
	rcp_end(T1, _A_),
	rcp_att(start, T2, _B_),
	fd_leq(_A_, _B_, _C_).

rcp_prec_search(T1, T2, _C_) :- 
	rcp_end_search(T1, _A_),
	rcp_att(start, T2, _B_),
	fd_leq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_disj(T1, T2, _C_) :- 
	fd_or(_A_, _B_, _C_),
	rcp_prec(T1, T2, _A_),
	rcp_prec(T2, T1, _B_).

rcp_disj_search(T1, T2, _C_) :- 
	(
	rcp_prec_search(T1, T2, _A_),
	rcp_assert(_A_)
	;
	rcp_prec_search(T2, T1, _B_),
	rcp_assert(_B_)
	),
	fd_aeq(_C_, 1).

rcp_disj_pairs_foldr_24([], _, 1) :- 
	!.
rcp_disj_pairs_foldr_24([T2_139|Tail], [T1_137,Tasks], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_implies(_C_, _D_, _E_),
	rcp_att(uid, T1_137, _A_),
	rcp_att(uid, T2_139, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_disj(T1_137, T2_139, _D_),
	rcp_disj_pairs_foldr_24(Tail, [T1_137,Tasks], _F_).

rcp_disj_pairs_foldr_24_search([], _, 1) :- 
	!.
rcp_disj_pairs_foldr_24_search([T2_139|Tail], [T1_137,Tasks], _) :- 
	rcp_att(uid, T1_137, _H_),
	rcp_att(uid, T2_139, _I_),
	rcp_att(uid, T1_137, _J_),
	rcp_att(uid, T2_139, _K_),
	(
	fd_lt(_H_, _I_),
	rcp_disj_search(T1_137, T2_139, _L_),
	fd_equiv(_L_, _M_, 1)
	;
	fd_geq(_J_, _K_),
	fd_aeq(_M_, 1)
	),
	rcp_assert(_M_),
	rcp_disj_pairs_foldr_24_search(Tail, [T1_137,Tasks], _N_),
	rcp_assert(_N_).

rcp_disj_pairs_foldr_23([], _, 1) :- 
	!.
rcp_disj_pairs_foldr_23([T1_137|Tail], [Tasks], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_disj_pairs_foldr_24(Tasks, [T1_137,Tasks], _A_),
	rcp_disj_pairs_foldr_23(Tail, [Tasks], _B_).

rcp_disj_pairs_foldr_23_search([], _, 1) :- 
	!.
rcp_disj_pairs_foldr_23_search([T1_137|Tail], [Tasks], _) :- 
	rcp_disj_pairs_foldr_24_search(Tasks, [T1_137,Tasks], _D_),
	rcp_assert(_D_),
	rcp_disj_pairs_foldr_23_search(Tail, [Tasks], _E_),
	rcp_assert(_E_).

rcp_disj_pairs(Tasks, _A_) :- 
	rcp_disj_pairs_foldr_23(Tasks, [Tasks], _A_).

rcp_disj_pairs_search(Tasks, _A_) :- 
	rcp_disj_pairs_foldr_23_search(Tasks, [Tasks], _A_).

solve([Ab1,Ab2,Ab3,Ab4,Ab5,Ab6,K1,K2,Ua,First,Ue,P2,P1,M6,V2,V1,M1,M2,M3,M5,M4,T1,T2,T3,T4,T5,L1,S6,S1,S2,S3,S5,S4,A6,A1,A2,A3,A5,A4,B1,B2,B3,B4,B6,B5,Last]) :- 
	statistics(runtime, [_Runtime_0_|_]),
	fd_statistics(backtracks, _),
	rcp_var(from(ab1,0,1), Ab1),
	rcp_var(from(ab2,0,1), Ab2),
	rcp_var(from(ab3,0,1), Ab3),
	rcp_var(from(ab4,0,1), Ab4),
	rcp_var(from(ab5,0,1), Ab5),
	rcp_var(from(ab6,0,1), Ab6),
	rcp_var(from(k1,0,1), K1),
	rcp_var(from(k2,0,1), K2),
	rcp_var(from(last,0,1), Last),
	rcp_var(from(ua,0,1), Ua),
	rcp_var(from(first,0,1), First),
	rcp_var(from(ue,0,1), Ue),
	rcp_var(from(p2,0,1), P2),
	rcp_var(from(p1,0,1), P1),
	rcp_var(from(m6,0,1), M6),
	rcp_var(from(v2,0,1), V2),
	rcp_var(from(v1,0,1), V1),
	rcp_var(from(m1,0,1), M1),
	rcp_var(from(m2,0,1), M2),
	rcp_var(from(m3,0,1), M3),
	rcp_var(from(m5,0,1), M5),
	rcp_var(from(m4,0,1), M4),
	rcp_var(from(t1,0,1), T1),
	rcp_var(from(t2,0,1), T2),
	rcp_var(from(t3,0,1), T3),
	rcp_var(from(t4,0,1), T4),
	rcp_var(from(t5,0,1), T5),
	rcp_var(from(l1,0,1), L1),
	rcp_var(from(s6,0,1), S6),
	rcp_var(from(s1,0,1), S1),
	rcp_var(from(s2,0,1), S2),
	rcp_var(from(s3,0,1), S3),
	rcp_var(from(s5,0,1), S5),
	rcp_var(from(s4,0,1), S4),
	rcp_var(from(a6,0,1), A6),
	rcp_var(from(a1,0,1), A1),
	rcp_var(from(a2,0,1), A2),
	rcp_var(from(a3,0,1), A3),
	rcp_var(from(a5,0,1), A5),
	rcp_var(from(a4,0,1), A4),
	rcp_var(from(b1,0,1), B1),
	rcp_var(from(b2,0,1), B2),
	rcp_var(from(b3,0,1), B3),
	rcp_var(from(b4,0,1), B4),
	rcp_var(from(b6,0,1), B6),
	rcp_var(from(b5,0,1), B5),
	domain([First,A1,A2,A3,A4,A5,A6,P1,P2,Ue,S1,S2,S3,S4,S5,S6,B1,B2,B3,B4,B5,B6,Ab1,Ab2,Ab3,Ab4,Ab5,Ab6,M1,M2,M3,M4,M5,M6,L1,T1,T2,T3,T4,T5,Ua,V1,V2,K1,K2,Last], 0, 271),
	First#=<A1,
	First#=<A2,
	First#=<A3,
	First#=<A4,
	First#=<A5,
	First#=<A6,
	First#=<Ue,
	A1+4#=<S1,
	A2+2#=<S2,
	A5+2#=<S5,
	A6+5#=<S6,
	A3+2#=<P1,
	A4+2#=<P2,
	P1+20#=<S3,
	P2+13#=<S4,
	P1+20#=<K1,
	P2+13#=<K1,
	S1+8#=<B1,
	S2+4#=<B2,
	S3+4#=<B3,
	S4+4#=<B4,
	S5+4#=<B5,
	S6+10#=<B6,
	B1+1#=<Ab1,
	B2+1#=<Ab2,
	B3+1#=<Ab3,
	B4+1#=<Ab4,
	B5+1#=<Ab5,
	B6+1#=<Ab6,
	Ab1+1#=<M1,
	Ab2+1#=<M2,
	Ab3+1#=<M3,
	Ab4+1#=<M4,
	Ab5+1#=<M5,
	Ab6+1#=<M6,
	M1+16#=<T1,
	M2+8#=<T1,
	M2+8#=<T2,
	M3+8#=<T2,
	M3+8#=<T3,
	M4+8#=<T3,
	M4+8#=<T4,
	M5+8#=<T4,
	M5+8#=<T5,
	M6+20#=<T5,
	M1+16#=<K2,
	M2+8#=<K2,
	M3+8#=<K2,
	M4+8#=<K2,
	M5+8#=<K2,
	M6+20#=<K2,
	L1+2#=<T1,
	L1+2#=<T2,
	L1+2#=<T3,
	L1+2#=<T4,
	L1+2#=<T5,
	T1+12#=<V1,
	T5+12#=<V2,
	T2+12#=<Last,
	T3+12#=<Last,
	T4+12#=<Last,
	V1+15#=<Last,
	V2+10#=<Last,
	Ua+10#=<Last,
	K1#=<Last,
	K2#=<Last,
	L1#=<First+30,
	S1#=<A1+4+3,
	S2#=<A2+2+3,
	S5#=<A5+2+3,
	S6#=<A6+5+3,
	S3#=<P1+20+3,
	S4#=<P2+13+3,
	M1+16#=<Ua+2,
	M2+8#=<Ua+2,
	M3+8#=<Ua+2,
	M4+8#=<Ua+2,
	M5+8#=<Ua+2,
	M6+20#=<Ua+2,
	B1+1#=<S1+8+4,
	B2+1#=<S2+4+4,
	B3+1#=<S3+4+4,
	B4+1#=<S4+4+4,
	B5+1#=<S5+4+4,
	B6+1#=<S6+10+4,
	L1#>=First+30,
	S1#>=Ue+6,
	S2#>=Ue+6,
	S3#>=Ue+6,
	S4#>=Ue+6,
	S5#>=Ue+6,
	S6#>=Ue+6,
	L1+2#=<T1#\/T1+12#=<L1,
	L1+2#=<T2#\/T2+12#=<L1,
	L1+2#=<T3#\/T3+12#=<L1,
	L1+2#=<T4#\/T4+12#=<L1,
	L1+2#=<T5#\/T5+12#=<L1,
	T1+12#=<T2#\/T2+12#=<T1,
	T1+12#=<T3#\/T3+12#=<T1,
	T1+12#=<T4#\/T4+12#=<T1,
	T1+12#=<T5#\/T5+12#=<T1,
	T2+12#=<T3#\/T3+12#=<T2,
	T2+12#=<T4#\/T4+12#=<T2,
	T2+12#=<T5#\/T5+12#=<T2,
	T3+12#=<T4#\/T4+12#=<T3,
	T3+12#=<T5#\/T5+12#=<T3,
	T4+12#=<T5#\/T5+12#=<T4,
	M1+16#=<M2#\/M2+8#=<M1,
	M1+16#=<M3#\/M3+8#=<M1,
	M1+16#=<M4#\/M4+8#=<M1,
	M1+16#=<M5#\/M5+8#=<M1,
	M1+16#=<M6#\/M6+20#=<M1,
	M2+8#=<M3#\/M3+8#=<M2,
	M2+8#=<M4#\/M4+8#=<M2,
	M2+8#=<M5#\/M5+8#=<M2,
	M2+8#=<M6#\/M6+20#=<M2,
	M3+8#=<M4#\/M4+8#=<M3,
	M3+8#=<M5#\/M5+8#=<M3,
	M3+8#=<M6#\/M6+20#=<M3,
	M4+8#=<M5#\/M5+8#=<M4,
	M4+8#=<M6#\/M6+20#=<M4,
	M5+8#=<M6#\/M6+20#=<M5,
	S1+8#=<S2#\/S2+4#=<S1,
	S1+8#=<S3#\/S3+4#=<S1,
	S1+8#=<S4#\/S4+4#=<S1,
	S1+8#=<S5#\/S5+4#=<S1,
	S1+8#=<S6#\/S6+10#=<S1,
	S2+4#=<S3#\/S3+4#=<S2,
	S2+4#=<S4#\/S4+4#=<S2,
	S2+4#=<S5#\/S5+4#=<S2,
	S2+4#=<S6#\/S6+10#=<S2,
	S3+4#=<S4#\/S4+4#=<S3,
	S3+4#=<S5#\/S5+4#=<S3,
	S3+4#=<S6#\/S6+10#=<S3,
	S4+4#=<S5#\/S5+4#=<S4,
	S4+4#=<S6#\/S6+10#=<S4,
	S5+4#=<S6#\/S6+10#=<S5,
	A1+4#=<A2#\/A2+2#=<A1,
	A1+4#=<A3#\/A3+2#=<A1,
	A1+4#=<A4#\/A4+2#=<A1,
	A1+4#=<A5#\/A5+2#=<A1,
	A1+4#=<A6#\/A6+5#=<A1,
	A2+2#=<A3#\/A3+2#=<A2,
	A2+2#=<A4#\/A4+2#=<A2,
	A2+2#=<A5#\/A5+2#=<A2,
	A2+2#=<A6#\/A6+5#=<A2,
	A3+2#=<A4#\/A4+2#=<A3,
	A3+2#=<A5#\/A5+2#=<A3,
	A3+2#=<A6#\/A6+5#=<A3,
	A4+2#=<A5#\/A5+2#=<A4,
	A4+2#=<A6#\/A6+5#=<A4,
	A5+2#=<A6#\/A6+5#=<A5,
	P1+20#=<P2#\/P2+13#=<P1,
	B1+1#=<B2#\/B2+1#=<B1,
	B1+1#=<B3#\/B3+1#=<B1,
	B1+1#=<B4#\/B4+1#=<B1,
	B1+1#=<B5#\/B5+1#=<B1,
	B1+1#=<B6#\/B6+1#=<B1,
	B2+1#=<B3#\/B3+1#=<B2,
	B2+1#=<B4#\/B4+1#=<B2,
	B2+1#=<B5#\/B5+1#=<B2,
	B2+1#=<B6#\/B6+1#=<B2,
	B3+1#=<B4#\/B4+1#=<B3,
	B3+1#=<B5#\/B5+1#=<B3,
	B3+1#=<B6#\/B6+1#=<B3,
	B4+1#=<B5#\/B5+1#=<B4,
	B4+1#=<B6#\/B6+1#=<B4,
	B5+1#=<B6#\/B6+1#=<B5,
	V1+15#=<V2#\/V2+10#=<V1,
	minimize((((M1+16#=<M6;M6+20#=<M1),(P1+20#=<P2;P2+13#=<P1),(M2+8#=<M6;M6+20#=<M2),(M3+8#=<M6;M6+20#=<M3),(M4+8#=<M6;M6+20#=<M4),(M5+8#=<M6;M6+20#=<M5),(V1+15#=<V2;V2+10#=<V1),(T1+12#=<T2;T2+12#=<T1),(T1+12#=<T3;T3+12#=<T1),(T1+12#=<T4;T4+12#=<T1),(T1+12#=<T5;T5+12#=<T1),(T2+12#=<T3;T3+12#=<T2),(T2+12#=<T4;T4+12#=<T2),(T2+12#=<T5;T5+12#=<T2),(T3+12#=<T4;T4+12#=<T3),(T3+12#=<T5;T5+12#=<T3),(T4+12#=<T5;T5+12#=<T4),(M1+16#=<M2;M2+8#=<M1),(M1+16#=<M3;M3+8#=<M1),(M1+16#=<M4;M4+8#=<M1),(M1+16#=<M5;M5+8#=<M1),(S1+8#=<S6;S6+10#=<S1),(M2+8#=<M3;M3+8#=<M2),(M2+8#=<M4;M4+8#=<M2),(M2+8#=<M5;M5+8#=<M2),(M3+8#=<M4;M4+8#=<M3),(M3+8#=<M5;M5+8#=<M3),(M4+8#=<M5;M5+8#=<M4),(L1+2#=<T1;T1+12#=<L1),(L1+2#=<T2;T2+12#=<L1),(L1+2#=<T3;T3+12#=<L1),(L1+2#=<T4;T4+12#=<L1),(L1+2#=<T5;T5+12#=<L1),(S2+4#=<S6;S6+10#=<S2),(S3+4#=<S6;S6+10#=<S3),(S4+4#=<S6;S6+10#=<S4),(S5+4#=<S6;S6+10#=<S5),(S1+8#=<S2;S2+4#=<S1),(S1+8#=<S3;S3+4#=<S1),(S1+8#=<S4;S4+4#=<S1),(S1+8#=<S5;S5+4#=<S1),(A1+4#=<A6;A6+5#=<A1),(S2+4#=<S3;S3+4#=<S2),(S2+4#=<S4;S4+4#=<S2),(S2+4#=<S5;S5+4#=<S2),(S3+4#=<S4;S4+4#=<S3),(S3+4#=<S5;S5+4#=<S3),(S4+4#=<S5;S5+4#=<S4),(A2+2#=<A6;A6+5#=<A2),(A3+2#=<A6;A6+5#=<A3),(A4+2#=<A6;A6+5#=<A4),(A5+2#=<A6;A6+5#=<A5),(A1+4#=<A2;A2+2#=<A1),(A1+4#=<A3;A3+2#=<A1),(A1+4#=<A4;A4+2#=<A1),(A1+4#=<A5;A5+2#=<A1),(A2+2#=<A3;A3+2#=<A2),(A2+2#=<A4;A4+2#=<A2),(A2+2#=<A5;A5+2#=<A2),(A3+2#=<A4;A4+2#=<A3),(A3+2#=<A5;A5+2#=<A3),(A4+2#=<A5;A5+2#=<A4),(B1+1#=<B2;B2+1#=<B1),(B1+1#=<B3;B3+1#=<B1),(B1+1#=<B4;B4+1#=<B1),(B1+1#=<B5;B5+1#=<B1),(B1+1#=<B6;B6+1#=<B1),(B2+1#=<B3;B3+1#=<B2),(B2+1#=<B4;B4+1#=<B2),(B2+1#=<B5;B5+1#=<B2),(B2+1#=<B6;B6+1#=<B2),(B3+1#=<B4;B4+1#=<B3),(B3+1#=<B5;B5+1#=<B3),(B3+1#=<B6;B6+1#=<B3),(B4+1#=<B5;B5+1#=<B4),(B4+1#=<B6;B6+1#=<B4),(B5+1#=<B6;B6+1#=<B5)),labeling([up],[Last])), Last),
	statistics(runtime, [_Runtime_1_|_]),
	fd_statistics(backtracks, _Backtracks_),
	_Runtime_ is _Runtime_1_-_Runtime_0_,
	format('~3d seconds\n', [_Runtime_]),
	format('~w bactracks\n\n', [_Backtracks_]).
