#!/bin/sh

if [ $# -ne 1 ]; then
   echo 1>&2 Usage: $0 version 
   exit 127
fi

p=$PWD
installdir=${p%/rules2cp/compiler/src}

sicstus --goal "compile(r2cp), make_r2cp('$installdir'), halt." &&

/afs/inria.fr/rocq/home/contraintes/common/lib/sp-4.0.4/bin/spld \
--output=r2cp \
--verbose \
--conf CC=/usr/bin/gcc \
--moveable \
--static r2cp.sav &&

mv r2cp.sav ../bin &&
mv r2cp ../bin/r2cp-$1
