package rules2cp.examples.packing;
import static rules2cp.interpreter.java.r2cp.*;
import rules2cp.interpreter.java.*;
import java.util.Vector;
import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.cp.solver.CPSolver;
import choco.cp.solver.search.integer.varselector.*;
import choco.cp.solver.search.integer.valselector.*;
import choco.cp.solver.search.integer.valiterator.*;
import choco.cp.solver.search.integer.branching.*;
import choco.cp.solver.constraints.global.geost.Constants;
import choco.cp.solver.constraints.global.geost.externalConstraints.ExternalConstraint;
import choco.cp.solver.constraints.global.geost.externalConstraints.NonOverlapping;
import choco.cp.solver.constraints.global.geost.geometricPrim.ShiftedBox;
import choco.kernel.model.Model;
import choco.kernel.model.constraints.*;
import choco.kernel.model.variables.*;
import choco.kernel.model.variables.integer.*;
import choco.kernel.model.variables.geost.GeostObject;
import choco.kernel.solver.Solver;
import choco.kernel.solver.branch.*;
import choco.kernel.solver.variables.integer.*;
import choco.kernel.model.variables.geost.*;

public class packing_polymorphism {

	public static void main(String[] args) {

		IntegerVariable reif_98 = makeIntVar("reif_98", 0, 1);
		IntegerVariable reif_99 = makeIntVar("reif_99", 0, 1);
		IntegerVariable reif_100 = makeIntVar("reif_100", 0, 1);
		IntegerVariable reif_101 = makeIntVar("reif_101", 0, 1);
		IntegerVariable reif_102 = makeIntVar("reif_102", 0, 1);
		IntegerVariable reif_103 = makeIntVar("reif_103", 0, 1);
		IntegerVariable reif_104 = makeIntVar("reif_104", 0, 1);
		IntegerVariable reif_105 = makeIntVar("reif_105", 0, 1);
		IntegerVariable reif_106 = makeIntVar("reif_106", 0, 1);
		IntegerVariable reif_107 = makeIntVar("reif_107", 0, 1);
		IntegerVariable reif_108 = makeIntVar("reif_108", 0, 1);
		IntegerVariable reif_109 = makeIntVar("reif_109", 0, 1);
		IntegerVariable reif_110 = makeIntVar("reif_110", 0, 1);
		IntegerVariable reif_111 = makeIntVar("reif_111", 0, 1);
		IntegerVariable reif_112 = makeIntVar("reif_112", 0, 1);
		IntegerVariable reif_113 = makeIntVar("reif_113", 0, 1);
		IntegerVariable reif_114 = makeIntVar("reif_114", 0, 1);
		IntegerVariable reif_115 = makeIntVar("reif_115", 0, 1);
		IntegerVariable reif_116 = makeIntVar("reif_116", 0, 1);
		IntegerVariable reif_117 = makeIntVar("reif_117", 0, 1);
		IntegerVariable reif_118 = makeIntVar("reif_118", 0, 1);
		IntegerVariable reif_119 = makeIntVar("reif_119", 0, 1);
		IntegerVariable reif_120 = makeIntVar("reif_120", 0, 1);
		IntegerVariable reif_121 = makeIntVar("reif_121", 0, 1);
		IntegerVariable o3_4 = rcp_var("from(o3, 4)");
		IntegerVariable o3_3 = rcp_var("from(o3, 3)");
		IntegerVariable o3 = rcp_var("from(o3, 1)");
		IntegerVariable o3_2 = rcp_var("from(o3, 2)");
		IntegerVariable o2_4 = rcp_var("from(o2, 4)");
		IntegerVariable o2_3 = rcp_var("from(o2, 3)");
		IntegerVariable o2 = rcp_var("from(o2, 1)");
		IntegerVariable o2_2 = rcp_var("from(o2, 2)");
		addConstraint(reifiedIntConstraint(reif_98, eq(o2_4, 1)));
		addConstraint(reifiedIntConstraint(reif_99, eq(o2_4, 2)));
		addConstraint(reifiedIntConstraint(reif_100, eq(o2_4, 1)));
		addConstraint(reifiedIntConstraint(reif_101, eq(o2_4, 2)));
		addConstraint(reifiedIntConstraint(reif_102, eq(o2_4, 1)));
		addConstraint(reifiedIntConstraint(reif_103, eq(o2_4, 2)));
		addConstraint(reifiedIntConstraint(reif_104, eq(o3_4, 1)));
		addConstraint(reifiedIntConstraint(reif_105, eq(o3_4, 2)));
		addConstraint(reifiedIntConstraint(reif_106, eq(o3_4, 1)));
		addConstraint(reifiedIntConstraint(reif_107, eq(o3_4, 2)));
		addConstraint(reifiedIntConstraint(reif_108, eq(o3_4, 1)));
		addConstraint(reifiedIntConstraint(reif_109, eq(o3_4, 2)));
		addConstraint(reifiedIntConstraint(reif_110, eq(o2_4, 1)));
		addConstraint(reifiedIntConstraint(reif_111, eq(o2_4, 2)));
		addConstraint(reifiedIntConstraint(reif_112, eq(o3_4, 1)));
		addConstraint(reifiedIntConstraint(reif_113, eq(o3_4, 2)));
		addConstraint(reifiedIntConstraint(reif_114, eq(o2_4, 1)));
		addConstraint(reifiedIntConstraint(reif_115, eq(o2_4, 2)));
		addConstraint(reifiedIntConstraint(reif_116, eq(o3_4, 1)));
		addConstraint(reifiedIntConstraint(reif_117, eq(o3_4, 2)));
		addConstraint(reifiedIntConstraint(reif_118, eq(o2_4, 1)));
		addConstraint(reifiedIntConstraint(reif_119, eq(o2_4, 2)));
		addConstraint(reifiedIntConstraint(reif_120, eq(o3_4, 1)));
		addConstraint(reifiedIntConstraint(reif_121, eq(o3_4, 2)));
		domain(new IntegerVariable[] {o2}, 0, 5);
		domain(new IntegerVariable[] {o2_2}, 0, 4);
		domain(new IntegerVariable[] {o2_3}, 0, 4);
		domain(new IntegerVariable[] {o3}, 0, 5);
		domain(new IntegerVariable[] {o3_2}, 0, 4);
		domain(new IntegerVariable[] {o3_3}, 0, 4);
		domain(new IntegerVariable[] {o2_4}, 1, 2);
		domain(new IntegerVariable[] {o3_4}, 1, 2);
		addConstraint(leq(0, o2));
		addConstraint(leq(plus(o2, plus(mult(reif_98, 4), mult(reif_99, 5))), 5));
		addConstraint(leq(0, o2_2));
		addConstraint(leq(plus(o2_2, plus(mult(reif_100, 5), mult(reif_101, 4))), 4));
		addConstraint(leq(0, o2_3));
		addConstraint(leq(plus(o2_3, plus(mult(reif_102, 2), mult(reif_103, 2))), 4));
		addConstraint(leq(0, o3));
		addConstraint(leq(plus(o3, plus(mult(reif_104, 4), mult(reif_105, 5))), 5));
		addConstraint(leq(0, o3_2));
		addConstraint(leq(plus(o3_2, plus(mult(reif_106, 5), mult(reif_107, 4))), 4));
		addConstraint(leq(0, o3_3));
		addConstraint(leq(plus(o3_3, plus(mult(reif_108, 2), mult(reif_109, 2))), 4));
		addConstraint(or(or(leq(plus(o2, plus(mult(reif_110, 4), mult(reif_111, 5))), o3), leq(plus(o3, plus(mult(reif_112, 4), mult(reif_113, 5))), o2)), or(or(leq(plus(o2_2, plus(mult(reif_114, 5), mult(reif_115, 4))), o3_2), leq(plus(o3_2, plus(mult(reif_116, 5), mult(reif_117, 4))), o2_2)), or(leq(plus(o2_3, plus(mult(reif_118, 2), mult(reif_119, 2))), o3_3), leq(plus(o3_3, plus(mult(reif_120, 2), mult(reif_121, 2))), o2_3)))));
		Solver s = new CPSolver();
		s.read(rules2cp.interpreter.java.r2cp.model);
		CPSolver.setVerbosity(CPSolver.SEARCH);
		s.attachGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o3_4, o3_3, o3, o3_2, o2_4, o2_3, o2, o2_2})), new IncreasingDomain()));
		s.generateSearchStrategy();
		s.launch();
		CPSolver.flushLogs();
		
	}

}
