:- use_module(library(lists)).
:- use_module(library(clpfd)).
:- ensure_loaded(geosr).

test_flat_geosr([O2_,O2_2,O2_3, O3_,O3_2,O3_3]) :-
	
	O2_ in 0..5, O2_2 in 0..4, O2_3 in 0..4,
	O3_ in 0..5, O3_2 in 0..4, O3_3 in 0..4,
	
	geosr([object(3, 5, [O2_,O2_2,O2_3], [weight-463]),
	       object(4, 5, [O3_,O3_2,O3_3], [weight-842])],
	      [sbox(5, [0,0,0], [4, 4, 2])],	      
	      [(O3_+5#=<O2_ #\/ O2_+4#=<O3_ #\/
	       O3_2+4#=<O2_2 #\/ O2_2+4#=<O3_2 #\/
	       O3_3+2#=<O2_3 #\/ O2_3+2#=<O3_3) ]),

	labeling([], [O2_,O2_2,O2_3, O3_,O3_2,O3_3]).


/*
0#=<O2_ #/\ O2_#=<5 #/\
0#=<O2_2 #/\ O2_2#=<4 #/\
0#=<O2_3 #/\ O2_3#=<4 #/\

0#=<O3_ #/\ O3_#=<5 #/\
0#=<O3_2 #/\ O3_2#=<4 #/\
0#=<O3_3 #/\ O3_3#=<4
*/